"use strict";

exports.__esModule = true;
exports.formatDistancePlus = formatDistancePlus;
var _dateFns = require("date-fns");
var _locale = require("date-fns/locale");
/**
 * 将时间转化为 `xxx前/后` 表示。
 *
 * @param date 时间
 * @param baseDate 基准时间（默认当前时间）
 */
function formatDistancePlus(date, baseDate) {
  if (baseDate === void 0) {
    baseDate = new Date();
  }
  var suffix = (0, _dateFns.isBefore)(date, baseDate) ? '前' : '后';
  var distance = (0, _dateFns.formatDistanceStrict)(date, baseDate, {
    locale: _locale.zhCN
  }).replace(/\s+/g, '');
  return "" + distance + suffix;
}