"use strict";

exports.__esModule = true;
exports.getCurrentPagePath = getCurrentPagePath;
var _ensureInMiniProgram = require("./ensureInMiniProgram");
var _utils = require("../utils");
/**
 * 获取当前页面的路径（不含查询参数），始终以 `/` 开头。
 *
 * @param pageInstance 页面实例，默认当前页面
 * @returns 返回当前页面的路径
 */
function getCurrentPagePath(pageInstance) {
  return (0, _ensureInMiniProgram.ensureInMiniProgram)(function () {
    pageInstance = pageInstance || (0, _utils.last)(getCurrentPages());
    var path = ("/" + (pageInstance.route || /* 字节跳动 */pageInstance.__route__)).replace(/\/{2,}/g, '/');
    return path;
  });
}