"use strict";

exports.__esModule = true;
exports.getSceneParams = getSceneParams;
var _getCurrentPageQuery2 = require("./getCurrentPageQuery");
var _utils = require("../utils");
/**
 * 获取场景参数。
 *
 * @param parser 解析器
 */
function getSceneParams(parser) {
  if (parser === void 0) {
    parser = 'searchParams';
  }
  var _getCurrentPageQuery = (0, _getCurrentPageQuery2.getCurrentPageQuery)(),
    scene = _getCurrentPageQuery.scene;
  if (!scene) {
    return {};
  }
  if (parser === 'searchParams') {
    return (0, _utils.parseUrlQueryString)(scene);
  }
  if (parser === 'json') {
    return JSON.parse(scene);
  }
  return parser(scene);
}