"use strict";

exports.__esModule = true;
exports.StringTemplate = void 0;
/**
 * 字符串模板。
 */
var StringTemplate = exports.StringTemplate = /*#__PURE__*/function () {
  function StringTemplate() {}
  /**
   * 渲染字符串模板。语法：
   *
   * - 用 `{key}` 直接替换；
   * - 用 `{key:param1,param2}` 执行函数替换；
   * - 用 `{{key==='test'?'hi':'hello'}}` 执行代码替换（内部使用 eval 实现，需开启选项里的 `code` 参数）。
   *
   * @param template 要渲染的模板
   * @param data 渲染数据
   * @param options 渲染选项
   * @returns 返回渲染后字符串
   */
  StringTemplate.render = function render(template, data, options) {
    var enableCode = !!(options != null && options.code);
    var keys = Object.keys(data);
    var _loop = function _loop() {
      var key = _keys[_i];
      template = typeof data[key] === 'function' ? template.replace(new RegExp("\\{" + key + "(:.+?)?\\}", 'g'), function (_, params) {
        var _data$key;
        return (_data$key = data[key]).call.apply(_data$key, [null].concat((params ? params.substring(1) : '').split(',')));
      }) : enableCode ? template.replace(new RegExp("(?<!\\$)\\{" + key + "\\}", 'g'), data[key]) : template.replaceAll("{" + key + "}", data[key]);
    };
    for (var _i = 0, _keys = keys; _i < _keys.length; _i++) {
      _loop();
    }
    if (enableCode) {
      template = template.replace(/\{\{(.+?)\}\}/g, function (_, code) {
        return eval("\n          (() => {\n            const {" + keys.join(',') + "} = " + JSON.stringify(data) + ";\n            return " + code + ";\n          })()\n        ");
      });
    }
    return template;
  };
  return StringTemplate;
}();