"use strict";

exports.__esModule = true;
exports.getEnvironment = getEnvironment;
var _inAndroid = require("./inAndroid");
var _inBrowser = require("./inBrowser");
var _inDeno = require("./inDeno");
var _inIOS = require("./inIOS");
var _inMiniProgram = require("./inMiniProgram");
var _inNodeJS = require("./inNodeJS");
var _inTaro = require("./inTaro");
var _inWechatWebView = require("./inWechatWebView");
var env;

/**
 * 获取运行环境信息。
 *
 * @returns 返回运行环境信息
 */
function getEnvironment() {
  if (env == null) {
    env = {
      browser: (0, _inBrowser.inBrowser)(),
      wechatWebView: (0, _inWechatWebView.inWechatWebView)(),
      miniProgram: !!(0, _inMiniProgram.inMiniProgram)(),
      wechatMiniProgram: !!(0, _inMiniProgram.inMiniProgram)('微信'),
      ios: (0, _inIOS.inIOS)(),
      android: (0, _inAndroid.inAndroid)(),
      nodejs: (0, _inNodeJS.inNodeJS)(),
      deno: (0, _inDeno.inDeno)(),
      taro: (0, _inTaro.inTaro)()
    };
  }
  return env;
}