"use strict";

exports.__esModule = true;
exports.inDeno = inDeno;
var yes;

/**
 * 检查是否在 Deno 中。
 *
 * @returns 返回检查结果
 * @example
 * ```typescript
 * if (inDeno()) {
 *   console.log('你在 Deno 中')
 * }
 * ```
 */
function inDeno() {
  if (yes == null) {
    yes = typeof Deno === 'object' && typeof Deno['version'] === 'object' && Deno['version']['deno'] != null;
  }
  return yes;
}