"use strict";

exports.__esModule = true;
exports.inIOS = inIOS;
var _inBrowser = require("./inBrowser");
var _inMiniProgram = require("./inMiniProgram");
var yes;

/**
 * 检查是否在 iOS 设备中。
 *
 * @returns 返回检查结果
 * @example
 * ```typescript
 * if (inIOS()) {
 *   console.log('你在 iOS 设备中')
 * }
 * ```
 */
function inIOS() {
  if (yes == null) {
    var mp = (0, _inMiniProgram.inMiniProgram)();
    if (mp) {
      var sysInfo = mp.getSystemInfoSync();
      yes = sysInfo.platform === 'ios' || /iOS/i.test(sysInfo.system);
    } else {
      yes = (0, _inBrowser.inBrowser)() && typeof window.navigator === 'object' && /iPad|iPhone|iPod/i.test(window.navigator.platform || '');
    }
  }
  return yes;
}