"use strict";

exports.__esModule = true;
exports.isDataUrl = isDataUrl;
var _regexp = require("../regexp");
var regExp = _regexp.dataUrlRegExpBuilder.build({
  exact: true
});

/**
 * 检测传入值是否是 Data URL。
 *
 * @public
 * @param value 要检测的值
 * @returns 返回检测结果
 * @example
 * ```typescript
 * isDataUrl('http://foo.bar') // => false
 * isDataUrl('data:text/plain;base64,SGVsbG8sIFdvcmxkIQ%3D%3D') // => true
 * ```
 */
function isDataUrl(value) {
  return regExp.test(value);
}