"use strict";

exports.__esModule = true;
exports.isEmail = isEmail;
var _regexp = require("../regexp");
var regExp = _regexp.emailRegExpBuilder.build({
  exact: true
});

/**
 * 检测传入值是否是邮箱地址。
 *
 * @public
 * @param value 要检测的值
 * @returns 返回检测结果
 * @example
 * ```typescript
 * isEmail('xx@gmail.com') // => true
 * isEmail('http://foo.bar') // => false
 * ```
 */
function isEmail(value) {
  return regExp.test(value);
}