"use strict";

exports.__esModule = true;
exports.isNumeric = isNumeric;
var _lodashUni = require("lodash-uni");
/**
 * 检查 `value` 是否是数值，需要注意的是 `Infinity`、`-Infinity`、`NaN` 不被认为是数值。
 *
 * @param value 要检查的值
 * @returns 返回检查结果
 * @example
 * ```typescript
 * isNumeric(1) // => true
 * isNumeric('1') // => true
 * ```
 */
function isNumeric(value) {
  return value != null && !(0, _lodashUni.isNaN)(value - parseFloat(value));
}