"use strict";

exports.__esModule = true;
exports.rot13 = rot13;
var input = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.split('');
var output = 'NOPQRSTUVWXYZABCDEFGHIJKLMnopqrstuvwxyzabcdefghijklm'.split('');
var lookup = input.reduce(function (m, k, i) {
  m[k] = output[i];
  return m;
}, Object.create(null));

/**
 * 回转 13 位替换式密码。
 *
 * @param str 原文
 * @see https://zh.wikipedia.org/wiki/ROT13
 * @example
 * ```typescript
 * rot13('hello world') // => 'uryyb jbeyq'
 * ```
 */
function rot13(str) {
  var res = '';
  for (var i = 0, len = str.length; i < len; i++) {
    var _char = str.charAt(i);
    res += lookup[_char] || _char;
  }
  return res;
}