"use strict";

exports.__esModule = true;
exports.sampleBy = sampleBy;
var _lodashUni = require("lodash-uni");
/**
 * 从集合中随机获得一个元素的迭代值。
 *
 * @param collection 集合
 * @param iteratee 迭代函数
 */

function sampleBy(collection, iteratee) {
  if ((0, _lodashUni.isArray)(collection)) {
    return (0, _lodashUni.sample)(collection.map(iteratee));
  } else if ((0, _lodashUni.isObject)(collection)) {
    var values = [];
    (0, _lodashUni.forOwn)(collection, function (v, k) {
      return values.push(iteratee(v, k));
    });
    return (0, _lodashUni.sample)(values);
  }
  return undefined;
}