"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
exports.__esModule = true;
exports.VaeBooleanSchema = void 0;
var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));
var _utils = require("../utils");
var _VaeLocale = require("./VaeLocale");
var _VaeSchema2 = require("./VaeSchema");
var VaeBooleanSchema = exports.VaeBooleanSchema = /*#__PURE__*/function (_VaeSchema) {
  (0, _inheritsLoose2.default)(VaeBooleanSchema, _VaeSchema);
  function VaeBooleanSchema(message) {
    var _this;
    if (message === void 0) {
      message = _VaeLocale.VaeLocale.boolean.type;
    }
    _this = _VaeSchema.call(this, {
      type: 'boolean'
    }) || this;
    _this.transform(Boolean).check({
      fn: _utils.isBoolean,
      message: message
    });
    return _this;
  }
  var _proto = VaeBooleanSchema.prototype;
  _proto.true = function _true(message) {
    if (message === void 0) {
      message = _VaeLocale.VaeLocale.boolean.true;
    }
    return this.check({
      fn: function fn(v) {
        return v === true;
      },
      message: message,
      tag: 'true'
    });
  };
  _proto.false = function _false(message) {
    if (message === void 0) {
      message = _VaeLocale.VaeLocale.boolean.false;
    }
    return this.check({
      fn: function fn(v) {
        return v === false;
      },
      message: message,
      tag: 'false'
    });
  };
  return VaeBooleanSchema;
}(_VaeSchema2.VaeSchema);