"use strict";

exports.__esModule = true;
exports.VaeSchemaBuilder = void 0;
var _VaeArraySchema = require("./VaeArraySchema");
var _VaeBooleanSchema = require("./VaeBooleanSchema");
var _VaeDateSchema = require("./VaeDateSchema");
var _VaeNumberSchema = require("./VaeNumberSchema");
var _VaeObjectSchema = require("./VaeObjectSchema");
var _VaeSchema = require("./VaeSchema");
var _VaeStringSchema = require("./VaeStringSchema");
var VaeSchemaBuilder = exports.VaeSchemaBuilder = function VaeSchemaBuilder() {
  var _this = this;
  this.string = function (schema, message) {
    return typeof schema === 'function' ? schema(new _VaeStringSchema.VaeStringSchema(message)) : new _VaeStringSchema.VaeStringSchema(schema);
  };
  this.stringOf = function (key, schema, message) {
    return _this.string(schema, message);
  };
  this.number = function (schema, message) {
    return typeof schema === 'function' ? schema(new _VaeNumberSchema.VaeNumberSchema(message)) : new _VaeNumberSchema.VaeNumberSchema(schema);
  };
  this.numberOf = function (key, schema, message) {
    return _this.number(schema, message);
  };
  this.date = function (schema, message) {
    return typeof schema === 'function' ? schema(new _VaeDateSchema.VaeDateSchema(message)) : new _VaeDateSchema.VaeDateSchema(schema);
  };
  this.dateOf = function (key, schema, message) {
    return _this.date(schema, message);
  };
  this.boolean = function (schema, message) {
    return typeof schema === 'function' ? schema(new _VaeBooleanSchema.VaeBooleanSchema(message)) : new _VaeBooleanSchema.VaeBooleanSchema(schema);
  };
  this.booleanOf = function (key, schema, message) {
    return _this.boolean(schema, message);
  };
  this.object = function (schema, message) {
    return typeof schema === 'function' ? schema(new _VaeObjectSchema.VaeObjectSchema(undefined, message)) : typeof schema === 'object' ? new _VaeObjectSchema.VaeObjectSchema(schema, message) : new _VaeObjectSchema.VaeObjectSchema(undefined, schema);
  };
  this.objectOf = function (key, schema, message) {
    return _this.object(schema, message);
  };
  this.array = function (schema, message) {
    return typeof schema === 'function' ? schema(new _VaeArraySchema.VaeArraySchema(undefined, message)) : schema instanceof _VaeSchema.VaeSchema ? new _VaeArraySchema.VaeArraySchema(schema, message) : new _VaeArraySchema.VaeArraySchema(undefined, schema);
  };
  this.arrayOf = function (key, schema, message) {
    return _this.array(schema, message);
  };
};