"use strict";

exports.__esModule = true;
exports.zhCN = exports.getZhCN = void 0;
/* istanbul ignore file */

var getZhCN = exports.getZhCN = function getZhCN(options) {
  var getLabel = options.getLabel;
  return {
    mixed: {
      default: function _default(params) {
        return getLabel(params) + "\u9519\u8BEF";
      },
      required: function required(params) {
        return getLabel(params) + "\u5FC5\u586B";
      },
      oneOf: function oneOf(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E0B\u5217\u503C\u4E4B\u4E00: " + params.values;
      },
      notOneOf: function notOneOf(params) {
        return getLabel(params) + "\u5FC5\u987B\u4E0D\u662F\u4E0B\u5217\u503C\u4E4B\u4E00: " + params.values;
      },
      defined: function defined(params) {
        return getLabel(params) + "\u5FC5\u987B\u5DF2\u5B9A\u4E49";
      },
      notType: function notType(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A" + (params.type === 'number' ? '数字' : params.type === 'string' ? '字符串' : params.type === 'boolean' ? '布尔值' : params.type === 'object' ? '对象' : params.type === 'array' ? '数组' : params.type === 'date' ? '日期' : " " + params.type + " \u7C7B\u578B\u7684\u503C");
      }
    },
    string: {
      length: function length(params) {
        return getLabel(params) + "\u5FC5\u987B\u4EC5\u5305\u542B" + params.length + "\u4F4D\u5B57\u7B26";
      },
      min: function min(params) {
        return getLabel(params) + "\u81F3\u5C11\u5E94\u5305\u542B" + params.min + "\u4F4D\u5B57\u7B26";
      },
      max: function max(params) {
        return getLabel(params) + "\u6700\u591A\u53EF\u5305\u542B" + params.max + "\u4F4D\u5B57\u7B26";
      },
      matches: function matches(params) {
        return getLabel(params) + "\u5FC5\u987B\u5339\u914D\u8BE5\u6B63\u5219\u8868\u8FBE\u5F0F: " + params.regex;
      },
      email: function email(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u5408\u6CD5\u7684\u90AE\u7BB1";
      },
      url: function url(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u4EE5 http:// \u6216 https:// \u5F00\u5934\u7684\u7F51\u7EDC\u94FE\u63A5";
      },
      trim: function trim(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u6CA1\u6709\u65C1\u767D\u7684\u5B57\u7B26\u4E32";
      },
      lowercase: function lowercase(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u5C0F\u5199\u7684\u5B57\u7B26\u4E32";
      },
      uppercase: function uppercase(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u5927\u5199\u7684\u5B57\u7B26\u4E32";
      },
      chineseMobilePhoneNumber: function chineseMobilePhoneNumber(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u5408\u6CD5\u7684\u624B\u673A\u53F7\u7801";
      },
      chineseIDCardNumber: function chineseIDCardNumber(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u5408\u6CD5\u7684\u8EAB\u4EFD\u8BC1\u53F7\u7801";
      }
    },
    number: {
      min: function min(params) {
        return getLabel(params) + "\u5FC5\u987B\u5927\u4E8E\u6216\u7B49\u4E8E" + params.min;
      },
      max: function max(params) {
        return getLabel(params) + "\u5FC5\u987B\u5C0F\u4E8E\u6216\u7B49\u4E8E" + params.max;
      },
      lessThan: function lessThan(params) {
        return getLabel(params) + "\u5FC5\u987B\u5C0F\u4E8E" + params.less;
      },
      moreThan: function moreThan(params) {
        return getLabel(params) + "\u5FC5\u987B\u5927\u4E8E" + params.more;
      },
      positive: function positive(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u6B63\u6570";
      },
      negative: function negative(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u8D1F\u6570";
      },
      integer: function integer(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u6574\u6570";
      },
      id: function id(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u6B63\u6574\u6570";
      },
      positiveInteger: function positiveInteger(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u6B63\u6574\u6570";
      },
      negativeInteger: function negativeInteger(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u8D1F\u6574\u6570";
      },
      nonPositive: function nonPositive(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u975E\u6B63\u6570";
      },
      nonNegative: function nonNegative(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u975E\u8D1F\u6570";
      },
      nonPositiveInteger: function nonPositiveInteger(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u975E\u6B63\u6574\u6570";
      },
      nonNegativeInteger: function nonNegativeInteger(params) {
        return getLabel(params) + "\u5FC5\u987B\u662F\u4E00\u4E2A\u975E\u8D1F\u6574\u6570";
      }
    },
    date: {
      min: function min(params) {
        return getLabel(params) + "\u5FC5\u987B\u665A\u4E8E" + params.min;
      },
      max: function max(params) {
        return getLabel(params) + "\u5FC5\u987B\u65E9\u4E8E" + params.max;
      }
    },
    boolean: {},
    object: {
      noUnknown: function noUnknown(params) {
        return getLabel(params) + "\u4E0A\u6709\u672A\u5B9A\u4E49\u7684\u952E: " + params.unknown;
      }
    },
    array: {
      min: function min(params) {
        return getLabel(params) + "\u81F3\u5C11\u5E94\u5305\u542B" + params.min + "\u4E2A\u5143\u7D20";
      },
      max: function max(params) {
        return getLabel(params) + "\u6700\u591A\u53EF\u5305\u542B" + params.max + "\u4E2A\u5143\u7D20";
      }
    }
  };
};
var zhCN = exports.zhCN = getZhCN({
  getLabel: function getLabel(params) {
    return params.label || '此项';
  }
});