"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;
exports.__esModule = true;
exports.RedisCookieJar = void 0;
var _ioredis = _interopRequireDefault(require("ioredis"));
var _toughCookie = require("tough-cookie");
var _utils = require("../utils");
var _toughCookieRedisstore = _interopRequireDefault(require("tough-cookie-redisstore"));
// @ts-ignore

const RedisCookieStore = _toughCookieRedisstore.default;
/**
 * 使用 Redis 作为 Cookie Jar。
 */
class RedisCookieJar extends _toughCookie.CookieJar {
  constructor(options) {
    const redis = (0, _utils.isPlainObject)(options.redis) ? new _ioredis.default(options.redis) : options.redis;
    super(new RedisCookieStore(`${RedisCookieJar.prefix}${options.key}`, {
      redis
    }), options);
  }
}
exports.RedisCookieJar = RedisCookieJar;
RedisCookieJar.prefix = '@@@@COOKIE@@@@';