import { formatDistanceStrict, isBefore } from 'date-fns';
import { zhCN } from 'date-fns/locale';

/**
 * 将时间转化为 `xxx前/后` 表示。
 *
 * @param date 时间
 * @param baseDate 基准时间（默认当前时间）
 */
export function formatDistancePlus(date, baseDate) {
  if (baseDate === void 0) {
    baseDate = new Date();
  }
  var suffix = isBefore(date, baseDate) ? '前' : '后';
  var distance = formatDistanceStrict(date, baseDate, {
    locale: zhCN
  }).replace(/\s+/g, '');
  return "" + distance + suffix;
}