import { createUrlQueryString } from "../utils/index.js";
import { ensureInMiniProgram } from "./ensureInMiniProgram.js";
import { getCurrentPagePath } from "./getCurrentPagePath.js";
import { getCurrentPageQuery } from "./getCurrentPageQuery.js";

/**
 * 获取当前页面的地址（包含查询参数）。
 *
 * @param pageInstance 页面实例，默认当前页面
 * @returns 返回当前页面的地址
 */
export function getCurrentPageUrl(pageInstance) {
  return ensureInMiniProgram(function () {
    var path = getCurrentPagePath(pageInstance);
    var query = getCurrentPageQuery(pageInstance);
    var queryString = createUrlQueryString(query);
    var url = "" + path + (queryString ? "?" + queryString : '');
    return url;
  });
}