import { getCurrentPageQuery } from "./getCurrentPageQuery.js";
import { parseUrlQueryString } from "../utils/index.js";
/**
 * 获取场景参数。
 *
 * @param parser 解析器
 */
export function getSceneParams(parser) {
  if (parser === void 0) {
    parser = 'searchParams';
  }
  var _getCurrentPageQuery = getCurrentPageQuery(),
    scene = _getCurrentPageQuery.scene;
  if (!scene) {
    return {};
  }
  if (parser === 'searchParams') {
    return parseUrlQueryString(scene);
  }
  if (parser === 'json') {
    return JSON.parse(scene);
  }
  return parser(scene);
}