import { createSubmit } from "../utils/index.js";
import { ensureInMiniProgram } from "./ensureInMiniProgram.js";

/**
 * 对提交类行为的封装。
 */
export var submit = createSubmit({
  start: function start(message) {
    ensureInMiniProgram(function (mp) {
      mp.showLoading({
        title: message || '',
        mask: true
      });
    });
  },
  fail: function fail(message, duration) {
    ensureInMiniProgram(function (mp) {
      mp.hideLoading();
      mp.showToast({
        title: message,
        icon: 'none',
        duration: duration
      });
    });
  },
  success: function success(message, duration) {
    ensureInMiniProgram(function (mp) {
      mp.hideLoading();
      mp.showToast({
        title: message,
        icon: 'success',
        duration: duration
      });
    });
  },
  complete: function complete() {
    ensureInMiniProgram(function (mp) {
      mp.hideLoading();
    });
  }
});