/**
 * React 工具库。基于 {@link https://github.com/streamich/react-use#readme | react-use}。
 *
 * @packageDocumentation
 */

/* istanbul ignore file */

// prettier-ignore
export {
// 手动导出以解决 cjs 下 Cannot redefine property 的问题
// @index(['../../node_modules/react-use/esm/{use,create}*.js', '!**/{useToggle,createGlobalState,useTitle,useInterval,useSearchParam,useLocalStorage,useWindowSize,useHover,createRouter,useKeyboardJs,useMeasureDirty,useSpring,useWait}.js'], (f, _) => `${f.name},`)
useAsync, useAsyncFn, useAsyncRetry, useAudio, useBattery, useBeforeUnload, useBoolean, useClickAway, useCookie, useCopyToClipboard, useCounter, useCss, useCustomCompareEffect, useDebounce, useDeepCompareEffect, useDefault, useDrop, useDropArea, useEffectOnce, useEnsuredForwardedRef, useError, useEvent, useFavicon, useFirstMountState, useFullscreen, useGeolocation, useGetSet, useGetSetState, useHarmonicIntervalFn, useHash, useHoverDirty, useIdle, useIntersection, useIsomorphicLayoutEffect, useKey, useKeyPress, useKeyPressEvent, useLatest, useLifecycles, useList, useLocation, useLockBodyScroll, useLogger, useLongPress, useMap, useMeasure, useMedia, useMediaDevices, useMediatedState, useMethods, useMotion, useMount, useMountedState, useMouse, useMouseHovered, useMouseWheel, useMultiStateValidator, useNetworkState, useNumber, useObservable, useOrientation, usePageLeave, usePermission, usePrevious, usePreviousDistinct, usePromise, useQueue, useRaf, useRafLoop, useRafState, useRendersCount, useScratch, useScroll, useScrollbarWidth, useScrolling, useSessionStorage, useSet, useSetState, useShallowCompareEffect, useSize, useSlider, useSpeech, useStartTyping, useStateList, useStateValidator, useStateWithHistory, useThrottle, useThrottleFn, useTimeout, useTimeoutFn, useTween, useUnmount, useUnmountPromise, useUpdate, useUpdateEffect, useUpsert, useVibrate, useVideo, useWindowScroll
// @endindex
} from 'react-use';

// @index(['./**/*.ts', '!./**/*.{test,taro}.*', '!./{useToggle,createGlobalState,useTitle,useInterval,useSearchParam,useLocalStorage,useWindowSize,useHover}.*'], f => `export * from '${f.path}'`)
export * from "./CommonComponentProps.js";
export * from "./defineComponent.js";
export * from "./DeriveComponentProps.js";
export * from "./isVisibleValue.js";
export * from "./renderComponent.js";
export * from "./useClassName.js";
export * from "./useControllableValue.js";
export * from "./useEnvironment.js";
export * from "./useLoadMore.js";
export * from "./useReachBottom.js";
export * from "./useScrollLoadMore.js";
export * from "./useStaged.js";
export * from "./useStateWithDeps.js";
export * from "./useValidator.js";
// @endindex

// 与 react-use 同名的应手动指定导出的模块
export { useToggle } from "./useToggle.js";
export { createGlobalState } from "./createGlobalState.js";
export { useTitle } from "./useTitle.js";
export { useInterval } from "./useInterval.js";
export { useSearchParam } from "./useSearchParam.js";
export { useLocalStorage } from "./useLocalStorage.js";
export { useWindowSize } from "./useWindowSize.js";
export { useHover } from "./useHover.js";