import { useEffect } from 'react';
import { useLoadMore } from "./useLoadMore.js";
import { useReachBottom } from "./useReachBottom.js";

/**
 * @public
 */

/**
 * 滚动数据加载。
 *
 * @public
 * @param service 数据加载服务
 * @param deps 依赖，依赖若发生变化则从首页重新加载数据
 * @param options 滚动选项
 * @returns 返回结果
 */
export function useScrollLoadMore(service, deps, options) {
  if (options === void 0) {
    options = {};
  }
  var loader = useLoadMore(service, deps);
  var containerRef = useReachBottom(loader.loadMore, options.offset || 0);
  useEffect(function () {
    if (options.containerRef && options.containerRef.current) {
      ;
      containerRef.current = options.containerRef.current;
    }
  }, [options.containerRef && options.containerRef.current]);
  return loader;
}