import { createUrlQueryString } from "./createUrlQueryString.js";
/**
 * 获取邮件链接。
 *
 * @param options 选项
 */
export function getEmailUrl(options) {
  var to = options.to,
    cc = options.cc,
    bcc = options.bcc,
    subject = options.subject,
    body = options.body;
  var url = "mailto:" + (Array.isArray(to) ? to.join(',') : to);
  if (cc || bcc || subject || body) {
    url += "?" + createUrlQueryString({
      cc: cc && (Array.isArray(cc) ? cc.join(',') : cc),
      bcc: bcc && (Array.isArray(bcc) ? bcc.join(',') : bcc),
      subject: subject,
      body: body
    });
  }
  return url;
}