import { inBrowser } from "./inBrowser.js";
import { inMiniProgram } from "./inMiniProgram.js";
var yes;

/**
 * 检查是否在 Android 设备中。
 *
 * @returns 返回检查结果
 * @example
 * ```typescript
 * if (inAndroid()) {
 *   console.log('你在 Android 设备中')
 * }
 * ```
 */
export function inAndroid() {
  if (yes == null) {
    var mp = inMiniProgram();
    if (mp) {
      var sysInfo = mp.getSystemInfoSync();
      yes = sysInfo.platform === 'android' || /Android/i.test(sysInfo.system);
    } else {
      yes = inBrowser() && typeof window.navigator === 'object' && /Android/i.test(window.navigator.userAgent || '');
    }
  }
  return yes;
}