var re = /^[0-9a-z]+$/;
/**
 * 检测传入值是否是 Cuid2。
 *
 * @param value 要检测的值
 * @returns 返回检测结果
 * @example
 * ```typescript
 * isCuid2('1') // => false
 * isCuid2('tz4a98xxat96iws9zmbrgj3a') // => true
 * ```
 * @see https://github.com/paralleldrive/cuid2
 */
export function isCuid2(value, options) {
  if (options === void 0) {
    options = {};
  }
  var _options = options,
    _options$minLength = _options.minLength,
    minLength = _options$minLength === void 0 ? 24 : _options$minLength,
    _options$maxLength = _options.maxLength,
    maxLength = _options$maxLength === void 0 ? 24 : _options$maxLength;
  return !!value && typeof value === 'string' && value.length >= minLength && value.length <= maxLength && re.test(value);
}