import { isPromiseLike } from "./isPromiseLike.js";

/**
 * 准备数据。
 *
 * @param getter 数据源
 */
export function prepareData(getter) {
  return Promise.all(Object.keys(getter).map(function (key) {
    var v = getter[key]();
    return isPromiseLike(v) ? v.then(function (value) {
      return [key, value];
    }) : [key, v];
  })).then(function (list) {
    return list.reduce(function (res, item) {
      res[item[0]] = item[1];
      return res;
    }, {});
  });
}