import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import { isArray } from "../utils/index.js";
import { VaeLocale } from "./VaeLocale.js";
import { VaeSchema } from "./VaeSchema.js";
export var VaeArraySchema = /*#__PURE__*/function (_VaeSchema) {
  _inheritsLoose(VaeArraySchema, _VaeSchema);
  function VaeArraySchema(element, message) {
    var _this;
    if (message === void 0) {
      message = VaeLocale.array.type;
    }
    _this = _VaeSchema.call(this, {
      type: 'array'
    }) || this;
    _this.check({
      fn: isArray,
      message: message
    });
    if (element) {
      _this.element(element);
    }
    return _this;
  }
  var _proto = VaeArraySchema.prototype;
  _proto.element = function element(_element) {
    return this.check({
      fn: _element,
      message: '',
      tag: 'element'
    });
  };
  _proto.nonempty = function nonempty(message) {
    if (message === void 0) {
      message = VaeLocale.array.nonempty;
    }
    return this.check({
      fn: function fn(v) {
        return v.length > 0;
      },
      message: message,
      tag: 'nonempty'
    });
  };
  _proto.min = function min(value, message) {
    if (message === void 0) {
      message = VaeLocale.array.min;
    }
    return this.check({
      fn: function fn(v) {
        return v.length >= value;
      },
      message: message,
      messageParams: {
        min: value
      },
      tag: 'min'
    });
  };
  _proto.max = function max(value, message) {
    if (message === void 0) {
      message = VaeLocale.array.max;
    }
    return this.check({
      fn: function fn(v) {
        return v.length <= value;
      },
      message: message,
      messageParams: {
        max: value
      },
      tag: 'max'
    });
  };
  _proto.length = function length(value, message) {
    if (message === void 0) {
      message = VaeLocale.array.length;
    }
    return this.check({
      fn: function fn(v) {
        return v.length === value;
      },
      message: message,
      messageParams: {
        length: value
      },
      tag: 'length'
    });
  };
  return VaeArraySchema;
}(VaeSchema);