import _extends from "@babel/runtime/helpers/esm/extends";
import { formatDate } from "../date/index.js";
export var VaeLocaleBuilder = /*#__PURE__*/function () {
  function VaeLocaleBuilder() {}
  VaeLocaleBuilder.zhCN = function zhCN(options) {
    return {
      base: {
        required: function required(payload) {
          return options.getLabel(payload) + "\u5E94\u5FC5\u586B";
        },
        enum: function _enum(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u4E0B\u5217\u503C\u4E4B\u4E00:" + payload.params.enum.join(',');
        },
        custom: function custom(payload) {
          return options.getLabel(payload) + "\u5E94\u6EE1\u8DB3\u81EA\u5B9A\u4E49\u89C4\u5219";
        }
      },
      string: {
        type: function type(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u5B57\u7B26\u4E32\u7C7B\u578B";
        },
        min: function min(payload) {
          return options.getLabel(payload) + "\u7684\u957F\u5EA6\u6700\u5C11\u5E94\u5230" + payload.params.min + "\u4F4D";
        },
        max: function max(payload) {
          return options.getLabel(payload) + "\u7684\u957F\u5EA6\u6700\u591A\u53EF\u5230" + payload.params.max + "\u4F4D";
        },
        length: function length(payload) {
          return options.getLabel(payload) + "\u7684\u957F\u5EA6\u5E94\u4E3A" + payload.params.length + "\u4F4D";
        },
        email: function email(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u4E00\u4E2A\u5408\u6CD5\u7684\u90AE\u7BB1";
        },
        url: function url(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u4E00\u4E2A\u5408\u6CD5\u7684\u7F51\u5740";
        },
        regex: function regex(payload) {
          return options.getLabel(payload) + "\u5E94\u6EE1\u8DB3\u6B63\u5219\u8868\u8FBE\u5F0F" + payload.params.regex;
        },
        includes: function includes(payload) {
          return options.getLabel(payload) + "\u5E94\u5305\u542B\u5B57\u7B26\u4E32" + payload.params.includes;
        },
        startsWith: function startsWith(payload) {
          return options.getLabel(payload) + "\u5E94\u4EE5\u5B57\u7B26\u4E32" + payload.params.startsWith + "\u5F00\u5934";
        },
        endsWith: function endsWith(payload) {
          return options.getLabel(payload) + "\u5E94\u4EE5\u5B57\u7B26\u4E32" + payload.params.endsWith + "\u7ED3\u5C3E";
        },
        phoneNumber: function phoneNumber(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u4E00\u4E2A\u5408\u6CD5\u7684\u624B\u673A\u53F7\u7801";
        },
        idCardNumber: function idCardNumber(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u4E00\u4E2A\u5408\u6CD5\u7684\u8EAB\u4EFD\u8BC1\u53F7\u7801";
        },
        cuid: function cuid(payload) {
          return options.getLabel(payload) + "\u6709\u8BEF";
        },
        cuid2: function cuid2(payload) {
          return options.getLabel(payload) + "\u6709\u8BEF";
        }
      },
      object: {
        type: function type(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u5BF9\u8C61\u7C7B\u578B";
        },
        requiredFieldsAtLeastOne: function requiredFieldsAtLeastOne(payload) {
          return options.getLabel(payload) + "\u4E2D\u81F3\u5C11\u6709\u4E00\u4E2A\u5B57\u6BB5\u5FC5\u586B:" + payload.params.keys.join(',');
        }
      },
      number: {
        type: function type(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u6570\u503C\u7C7B\u578B";
        },
        min: function min(payload) {
          return options.getLabel(payload) + "\u5E94\u5927\u4E8E\u6216\u7B49\u4E8E" + payload.params.min;
        },
        max: function max(payload) {
          return options.getLabel(payload) + "\u5E94\u5C0F\u4E8E\u6216\u7B49\u4E8E" + payload.params.max;
        },
        lessThan: function lessThan(payload) {
          return options.getLabel(payload) + "\u5E94\u5C0F\u4E8E" + payload.params.lessThan;
        },
        moreThan: function moreThan(payload) {
          return options.getLabel(payload) + "\u5E94\u5927\u4E8E" + payload.params.moreThan;
        },
        integer: function integer(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u4E00\u4E2A\u6574\u6570";
        },
        positive: function positive(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u4E00\u4E2A\u6B63\u6570";
        },
        nonpositive: function nonpositive(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u4E00\u4E2A\u975E\u6B63\u6570";
        },
        negative: function negative(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u4E00\u4E2A\u8D1F\u6570";
        },
        nonnegative: function nonnegative(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u4E00\u4E2A\u975E\u8D1F\u6570";
        },
        positiveInteger: function positiveInteger(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u4E00\u4E2A\u6B63\u6574\u6570";
        }
      },
      boolean: {
        type: function type(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u5E03\u5C14\u7C7B\u578B";
        },
        true: function _true(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u771F\u503C";
        },
        false: function _false(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u5047\u503C";
        }
      },
      array: {
        type: function type(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u6570\u7EC4\u7C7B\u578B";
        },
        nonempty: function nonempty(payload) {
          return options.getLabel(payload) + "\u5E94\u975E\u7A7A";
        },
        min: function min(payload) {
          return options.getLabel(payload) + "\u5E94\u81F3\u5C11\u5305\u542B" + payload.params.min + "\u4E2A\u5143\u7D20";
        },
        max: function max(payload) {
          return options.getLabel(payload) + "\u5E94\u6700\u591A\u5305\u542B" + payload.params.max + "\u4E2A\u5143\u7D20";
        },
        length: function length(payload) {
          return options.getLabel(payload) + "\u5E94\u4EC5\u5305\u542B" + payload.params.max + "\u4E2A\u5143\u7D20";
        }
      },
      date: {
        type: function type(payload) {
          return options.getLabel(payload) + "\u5E94\u662F\u65E5\u671F\u7C7B\u578B";
        },
        min: function min(payload) {
          return options.getLabel(payload) + "\u5E94\u5927\u4E8E\u6216\u7B49\u4E8E" + formatDate(payload.params.min, 'yyyy-mm-dd hh:ii:ss');
        },
        max: function max(payload) {
          return options.getLabel(payload) + "\u5E94\u5C0F\u4E8E\u6216\u7B49\u4E8E" + formatDate(payload.params.max, 'yyyy-mm-dd hh:ii:ss');
        }
      }
    };
  };
  return VaeLocaleBuilder;
}();
export var VaeLocale = _extends({}, VaeLocaleBuilder.zhCN({
  getLabel: function getLabel(payload) {
    return payload.label || payload.path.join('.') || '.';
  }
}), {
  $set: function $set(locale) {
    Object.assign(VaeLocale, locale);
  }
});